#include "web_server.h"
#include <signal.h>
#include <stdlib.h>



int PORT=80;



void startpage(char *topic) {
	printf("Content-type: text/html\r\n\r\n");
	printf("<HTML>
	<body bgcolor='EFEFFF'>
	<CENTER>
		<TABLE><TR><TD align=center>
			<a href='libwebserver.sourceforge.net'><img border=0 src='/libwebserver.gif'></a>
		</TD><TR><TR><TD align=center>
			<font face='Verdana'><B>HELP<BR>(%s)</B></font>
		</TD></TR></TABLE>
	</CENTER>
	<HR><BR>\n",topic);
};
void endpage() {
	printf("<HR><p align=right> <small> by Luis Figueiredo (<a href='mailto:stdio@netc.pt'>stdio@netc.pt</a>) (%s)</BODY></HTML>\n",_libwebserver_version);
};

void log() {
	startpage("logfile");
	printf("<PRE>\n");
	web_client_addfile("help.log");
	printf("</PRE>\n");
	endpage();
};

struct image {
	char *data;
	size_t size;
} image={NULL,0};

void imageout() {
	if(strlen(ClientInfo->Query("img"))) {
		if(image.data!=NULL) {
			printf("Content-type: image/jpeg\r\n\r\n");
			fwrite(image.data,image.size,1,stdout);
		};
		return;
	};
	startpage("Image example");
	printf("<form action='/image' method='POST' enctype='multipart/form-data'>\n");
	printf("<input type=file name=image><BR>\n");
	printf("<input type=submit name='GOO' value='See'>\n");
	printf("</form>\n");
	if(strlen(ClientInfo->MultiPart("image").data)) {
		printf("%s<BR><img src='/image?img=%s.jpg'>\n",ClientInfo->MultiPart("image").filename,ClientInfo->MultiPart("image").filename);
		free(image.data);
		image.data=malloc(ClientInfo->MultiPart("image").size+1);
		memcpy(image.data,ClientInfo->MultiPart("image").data,ClientInfo->MultiPart("image").size);
		image.size=ClientInfo->MultiPart("image").size;
	}else {
		free(image.data);
		image.data=NULL;
	};
	endpage();
};
void urlauthenticate() {
        if(!strlen(ClientInfo->user) || !strlen(ClientInfo->pass) &&
            strcmp(ClientInfo->user,"username") || strcmp(ClientInfo->pass,"password")) { // you can read things from a auth file
                web_client_HTTPdirective("HTTP/1.1 401 Authorization Required");
                printf("WWW-Authenticate: Basic realm=\"This site info\"\r\n");
		startpage("Authenticate example");
                printf("<CENTER><font color='FF0000'>Access denied</font></CENTER>\n");
		endpage();
                return;
        }
	startpage("Authenticate example");
        printf("You entered in your area\n");
	endpage();
};


void help() {
	// info
	// engine
	// functions help
	// functionall examples
	// security
	// regards
	// authors
	if(!strlen(ClientInfo->Query("help"))) {	
		startpage("Table of contents");
		printf("<ol>\n");
		printf("<li><a href='/?help=info'>libwebserver info</a></li>\n");
		printf("<ul><li><a href='/?help=info#what'>What's libwebserver for?</a></li></ul>\n");
		printf("<ul><li><a href='/?help=info#who'>Who's suposed to use libwebserver?</a></li></ul>\n");
		printf("<ul><li><a href='/?help=info#when'>When i'm suposed to use libwebserver?</a></li></ul>\n");
		printf("<ul><li><a href='/?help=info#server_scripts'>It suport server scripts such as .php .cgi .asp?</a></li></ul>\n");
		printf("<li><a href='/?help=engine'>libwebserver engine</a></li>\n");
		printf("<ul><li><a href='/?help=engine#how'>How it works?</a></li></ul>\n");
		printf("<ul><li><a href='/?help=engine#modules'>Modules description</a></li></ul>\n");
		printf("<ul><li><a href='/?help=engine#structures'>internal data structures</a></li></ul>\n");
		printf("<li><a href='/?help=functions'>libwebserver functions</a></li>\n");	
		printf("<ul><li><a href='/?help=functions#web_server_init'>web_server_init()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_server_addhandler'>web_server_addhandler()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_server_run'>web_server_run()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_server_useSSLcert'>web_server_useSSLcert()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_client_addstream'>web_client_addstream()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_client_addfile'>web_client_addfile()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_client_HTTPdirective'>web_client_HTTPdirective()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_log'>web_log()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#ClientInfo'>ClientInfo</a></li></ul>\n");	
		printf("<li><a href='/?help=examples'>libwebserver examples</a></li>\n");
		printf("<ul><li><a href='/?help=examples#logfile'>Show's log file</a></li></ul>\n");
		printf("<ul><li><a href='/?help=examples#imageup'>Image Uploader</a></li></ul>\n");
		printf("<ul><li><a href='/?help=examples#auth'>Authentication</a></li></ul>\n");
		printf("<ul><li><a href='/?help=examples#ssl'>Openssl for (https)</a></li></ul>\n");
		printf("<ul><li><a href='/brokenlink'>Broken link</a></li></ul>\n");
		printf("<li><a href='/?help=security'>libwebserver security</a></li>\n");
		printf("<ul><li><a href='/?help=security#safe'>Its safe to use?</a></li></ul>\n");
		printf("<li><a href='/?help=Authors'>Authors</a></li>\n");
		printf("</ol>\n");
		endpage();	
		return;	
	};

	startpage(ClientInfo->Query("help"));
	if(!strcmp(ClientInfo->Query("help"),"info")) {
		web_client_addfile("help.html/info.html");
	};
	if(!strcmp(ClientInfo->Query("help"),"engine")) {
		web_client_addfile("help.html/engine.html");
	};
	if(!strcmp(ClientInfo->Query("help"),"security")) {
		web_client_addfile("help.html/security.html");
	};
	if(!strcmp(ClientInfo->Query("help"),"functions")) {
		web_client_addfile("help.html/functions.html");
	};
	if(!strcmp(ClientInfo->Query("help"),"examples")) {
		printf("<center><H3><font color='007700'>libwebserver examples</font></H3></center><BR><BR>\n");
		printf("<A name=logfile><B><font color='000077'><a href='/log'><H3>logfile</H3></a></font></B>\n");
printf("<UL>
<PRE>
<FONT color=#ff40ff>#include </FONT><FONT color=#ff6060>&quot;web_server.h&quot;</FONT>



<FONT color=#00ff00>void</FONT> log() {
        printf(<FONT color=#ff6060>&quot;Content-type: text/plain</FONT><FONT color=#ff40ff>\\r\\n\\r\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        web_client_addfile(<FONT color=#ff6060>&quot;help.log&quot;</FONT>); <FONT color=#8080ff>// adding help.log file to output</FONT>
        printf(<FONT color=#ff6060>&quot;End of log</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
};
        

main() {
        <FONT color=#00ff00>struct</FONT> web_server server; <FONT color=#8080ff>// server handler</FONT>
        <FONT color=#ffff00>if</FONT>(!web_server_init(&amp;server,<FONT color=#ff6060>82</FONT>,<FONT color=#ff6060>&quot;help.log&quot;</FONT>,<FONT color=#ff6060>0</FONT>)) { <FONT color=#8080ff>// initializate</FONT>
                fprintf(<FONT color=#ff6060>stderr</FONT>,<FONT color=#ff6060>&quot;can't open listen socket</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        };

        web_server_addhandler(&amp;server,<FONT color=#ff6060>&quot;.* /log&quot;</FONT>,log,<FONT color=#ff6060>0</FONT>); <FONT color=#8080ff>// adding handler for http://host/log requests</FONT>
        <FONT color=#ffff00>while</FONT>(<FONT color=#ff6060>1</FONT>) {
                web_server_run(&amp;server);   <FONT color=#8080ff>// run server</FONT>
        };
};

</PRE></UL>");
		printf("<HR><BR>\n");
		printf("<A name=imageup><B><font color='000077'><a href='/image'><H3>Image Uploader</H3></a></font></B>\n");

printf("<UL>
<PRE>
<FONT color=#ff40ff>#include </FONT><FONT color=#ff6060>&quot;web_server.h&quot;</FONT>
                
<FONT color=#ff40ff>#include </FONT><FONT color=#ff6060>&lt;stdlib.h&gt;</FONT>
        
<FONT color=#00ff00>struct</FONT> image {
        <FONT color=#00ff00>char</FONT> *data;
        <FONT color=#00ff00>size_t</FONT> size;
} image={<FONT color=#ff6060>NULL</FONT>,<FONT color=#ff6060>0</FONT>};

<FONT color=#00ff00>void</FONT> imageout() {
        <FONT color=#ffff00>if</FONT>(strlen(ClientInfo-&gt;Query(<FONT color=#ff6060>&quot;img&quot;</FONT>))) {
                <FONT color=#ffff00>if</FONT>(image.data!=<FONT color=#ff6060>NULL</FONT>) {
                        printf(<FONT color=#ff6060>&quot;Content-type: image/jpeg</FONT><FONT color=#ff40ff>\\r\\n\\r\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
                        fwrite(image.data,image.size,<FONT color=#ff6060>1</FONT>,<FONT color=#ff6060>stdout</FONT>);
                };
                <FONT color=#ffff00>return</FONT>;
        };
        printf(<FONT color=#ff6060>&quot;Content-type: text/html</FONT><FONT color=#ff40ff>\\r\\n\\r\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        printf(<FONT color=#ff6060>&quot;&lt;HTML&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        printf(<FONT color=#ff6060>&quot;&lt;BODY bgcolor='EFEFEF'&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);        
	printf(<FONT color=#ff6060>&quot;&lt;form action='/' enctype='multipart/form-data'&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        printf(<FONT color=#ff6060>&quot;&lt;input type=file name=image&gt;&lt;BR&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        printf(<FONT color=#ff6060>&quot;&lt;/form&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        <FONT color=#ffff00>if</FONT>(strlen(ClientInfo-&gt;MultiPart(<FONT color=#ff6060>&quot;image&quot;</FONT>).data)) {
                printf(<FONT color=#ff6060>&quot;</FONT><FONT color=#ff40ff>%%s</FONT><FONT color=#ff6060>&lt;BR&gt;&lt;img src='/?img=</FONT><FONT color=#ff40ff>%%s</FONT><FONT color=#ff6060>.jpg'&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>,ClientInfo-&gt;MultiPart(<FONT color=#ff6060>&quot;image&quot;</FONT>).filename,ClientInfo-&gt;MultiPart(<FONT color=#ff6060>&quot;image&quot;</FONT>).filename);
                free(image.data);
                image.data=malloc(ClientInfo-&gt;MultiPart(<FONT color=#ff6060>&quot;image&quot;</FONT>).size+<FONT color=#ff6060>1</FONT>);
                memcpy(image.data,ClientInfo-&gt;MultiPart(<FONT color=#ff6060>&quot;image&quot;</FONT>).data,ClientInfo-&gt;MultiPart(<FONT color=#ff6060>&quot;image&quot;</FONT>).size);
                image.size=ClientInfo-&gt;MultiPart(<FONT color=#ff6060>&quot;image&quot;</FONT>).size;
        }<FONT color=#ffff00>else</FONT> {
                free(image.data);
                image.data=<FONT color=#ff6060>NULL</FONT>;
        };
        printf(<FONT color=#ff6060>&quot;&lt;/BODY&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        printf(<FONT color=#ff6060>&quot;&lt;/HTML&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
};




main() {
        <FONT color=#00ff00>struct</FONT> web_server server;
        <FONT color=#ffff00>if</FONT>(!web_server_init(&amp;server,<FONT color=#ff6060>80</FONT>,<FONT color=#ff6060>&quot;teste.log&quot;</FONT>,<FONT color=#ff6060>0</FONT>)) {
                fprintf(<FONT color=#ff6060>stderr</FONT>,<FONT color=#ff6060>&quot;can't open listen socket</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        };
        web_server_addhandler(&amp;server,<FONT color=#ff6060>&quot;.* /&quot;</FONT>,index,<FONT color=#ff6060>0</FONT>);
        <FONT color=#ffff00>while</FONT>(<FONT color=#ff6060>1</FONT>) {
                web_server_run(&amp;server);
        };
};
</PRE></UL>");

		printf("<HR><BR>\n");
		printf("<A name=auth><B><font color='000077'><a href='/auth'><H3>Authentication</H3></a> user: \"username\", pass: \"password\"</font></B>\n");
printf("<UL>
<PRE>
<FONT color=#ff40ff>#include </FONT><FONT color=#ff6060>&quot;web_server.h&quot;</FONT>


<FONT color=#00ff00>void</FONT> urlauthenticate() {
        <FONT color=#ffff00>if</FONT>(!strlen(ClientInfo-&gt;user) || !strlen(ClientInfo-&gt;pass) &amp;&amp;
            strcmp(ClientInfo-&gt;user,<FONT color=#ff6060>&quot;username&quot;</FONT>) || strcmp(ClientInfo-&gt;pass,<FONT color=#ff6060>&quot;password&quot;</FONT>)) { <FONT color=#8080ff>// you can read things from a auth file</FONT>
                web_client_HTTPdirective(<FONT color=#ff6060>&quot;HTTP/1.1 401 Authorization Required&quot;</FONT>);
                printf(<FONT color=#ff6060>&quot;WWW-Authenticate: Basic realm=</FONT><FONT color=#ff40ff>\\&quot;</FONT><FONT color=#ff6060>This site info</FONT><FONT color=#ff40ff>\\&quot;\\r\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
                printf(<FONT color=#ff6060>&quot;Content-type: text/html</FONT><FONT color=#ff40ff>\\r\\n\\r\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
                printf(<FONT color=#ff6060>&quot;&lt;BODY&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
                printf(<FONT color=#ff6060>&quot;&lt;font color='FF0000'&gt;Access denied&lt;/font&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
                printf(<FONT color=#ff6060>&quot;&lt;/BODY&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
                <FONT color=#ffff00>return</FONT>;
        }
        printf(<FONT color=#ff6060>&quot;Content-type: text/html</FONT><FONT color=#ff40ff>\\r\\n\\r\\n</FONT><FONT color=#ff6060>&quot;</FONT>);        
	printf(<FONT color=#ff6060>&quot;&lt;BODY bgcolor='EFEFEF'&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);        
	printf(<FONT color=#ff6060>&quot;You entered in your area</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        printf(<FONT color=#ff6060>&quot;&lt;/BODY&gt;&lt;/HTML&gt;</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
};


main() {
        <FONT color=#00ff00>struct</FONT> web_server server; <FONT color=#8080ff>// server handler</FONT>
        <FONT color=#ffff00>if</FONT>(!web_server_init(&amp;server,<FONT color=#ff6060>83</FONT>,<FONT color=#ff6060>&quot;help.log&quot;</FONT>,<FONT color=#ff6060>0</FONT>)) { <FONT color=#8080ff>// initializate</FONT>
                fprintf(<FONT color=#ff6060>stderr</FONT>,<FONT color=#ff6060>&quot;can't open listen socket</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        };

        web_server_addhandler(&amp;server,<FONT color=#ff6060>&quot;.* /auth&quot;</FONT>,urlauthenticate,<FONT color=#ff6060>0</FONT>); <FONT color=#8080ff>// adding handler for http://host/log requests</FONT>
        <FONT color=#ffff00>while</FONT>(<FONT color=#ff6060>1</FONT>) {
                web_server_run(&amp;server);   <FONT color=#8080ff>// run server</FONT>
        };
};
</PRE></UL>");
		printf("<HR><BR>\n");
		printf("<A name=ssl><B><font color='000077'><H3>openssl for (https)</H3></font></B>\n");
printf("<UL>
I can't make here a pratic example since this server was not compiled with openssl, but it is almost the same
<PRE>   
<FONT color=#00ff00>int</FONT> main()
        <FONT color=#00ff00>struct</FONT> web_server serverssl;
        web_server_useSSLcert(&amp;serverssl,<FONT color=#ff6060>&quot;foo-cert.pem&quot;</FONT>); <FONT color=#8080ff>// Certificate file</FONT>    
        <FONT color=#ffff00>if</FONT>(!web_server_init(&amp;serverssl,<FONT color=#ff6060>443</FONT>,<FONT color=#ff6060>&quot;help.log&quot;</FONT>,WS_USESSL)) {
                fprintf(<FONT color=#ff6060>stderr</FONT>,<FONT color=#ff6060>&quot;Cannot open port</FONT><FONT color=#ff40ff>\\n</FONT><FONT color=#ff6060>&quot;</FONT>);
        };
        <FONT color=#ffff00>while</FONT>(<FONT color=#ff6060>1</FONT>) {
                web_server_run(&amp;serverssl);
        };
};
</PRE>
All the rest is the same as normal libwebserver
</UL>");

	};
	if(!strcmp(ClientInfo->Query("help"),"Authors")) {
		printf("Luis Figueiredo (<a href='mailto:stdio@netc.pt'>stdio@netc.pt</a>) - Main programmer, designer\n");
	};
	endpage();	
};



int main() {
	struct web_server server;
	int pid;
	FILE *pidf;
	while(!web_server_init(&server,PORT,"help.log",0))PORT++;
	web_server_addhandler(&server,"* /",help,0);
	web_server_addhandler(&server,"* /log",log,0);
	web_server_addhandler(&server,"* /image",imageout,0);
	web_server_addhandler(&server,"* /auth",urlauthenticate,0);
	printf("http://localhost:%d\n",PORT);
	while(1) {
		web_server_run(&server);
	};


};
