/* by Luis Figueiredo (stdio@netc.pt)
 *
 * file: utils.h
 *
 * description: Header
 *
 * date: 19:50,07-50-2002
 */

#ifndef _UTILS_H_ 
#define _UTILS_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif         

#include "debug.h"
#include "memory.h"


char *strcasestr(char *, const char *);
int hextoi(char *);
int base64decode(char *, const char *);

#endif
